/**
 * AdRemote.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Mar 02, 2009 (07:08:06 PST) WSDL2Java emitter.
 */

package com.google.api.ads.dfa.axis.v1_18;

public interface AdRemote extends java.rmi.Remote {

    /**
     * Returns the ad with the given id.
     *         The client is responsible for down-casting the returned ad
     * object into a specific type like
     *         CreativeAd or ClickTracker or RotationGroup.
     */
    public com.google.api.ads.dfa.axis.v1_18.AdBase getAd(long adId) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Saves (inserts/updates) the given ad object.
     *         If the id of the specified object is <= 0, then it will create
     * a new ad,
     *         else it will update the ad with that id.
     */
    public com.google.api.ads.dfa.axis.v1_18.AdSaveResult saveAd(com.google.api.ads.dfa.axis.v1_18.AdBase ad) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Deletes the ad with the given id.
     */
    public void deleteAd(long adId) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Creates copy of the given Ads.
     */
    public com.google.api.ads.dfa.axis.v1_18.AdCopyResult[] copyAds(com.google.api.ads.dfa.axis.v1_18.AdCopyRequest[] adCopyRequests) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a single page of ads matching the given criteria.
     *         The criteria must specify a campaign. The maximum 1000 ads
     * can be retrieved
     *         in single page or request. The page size can be specified
     * in the criteria.
     *         If  page size is not specified in search criteria then it
     * will assume a maximum page size
     *         of 1000. Also it gives error message in case page size exceeds
     * maximum limit of 1000.
     */
    public com.google.api.ads.dfa.axis.v1_18.AdRecordSet getAds(com.google.api.ads.dfa.axis.v1_18.AdSearchCriteria adSearchCriteria) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns type of ads.
     */
    public com.google.api.ads.dfa.axis.v1_18.AdType[] getAdTypes() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns the list of targetable designated market areas.
     */
    public com.google.api.ads.dfa.axis.v1_18.DesignatedMarketArea[] getDesignatedMarketAreas() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns the list of targetable countries.
     */
    public com.google.api.ads.dfa.axis.v1_18.Country[] getCountries() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a list of regions in given countries.
     */
    public com.google.api.ads.dfa.axis.v1_18.Region[] getRegions(long[] countryIds) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a list of targetable states in given countries.
     */
    public com.google.api.ads.dfa.axis.v1_18.State[] getStates(long[] countryIds) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a list of targetable area codes in given countries.
     */
    public com.google.api.ads.dfa.axis.v1_18.AreaCode[] getAreaCodes(long[] countryIds) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a list of targetable cities in the given countries
     * and/or
     *         regions. It returns a union of cities that fall in the given
     * regions and
     *         those that fall in the given countries that do not have any
     * region
     *         specified. So if the country and its region are both in the
     * paramater
     *         arrays, then only the cities for that region will be included.
     */
    public com.google.api.ads.dfa.axis.v1_18.City[] getCities(com.google.api.ads.dfa.axis.v1_18.CitySearchCriteria citySearchCriteria) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a list of targetable browsers.
     */
    public com.google.api.ads.dfa.axis.v1_18.Browser[] getBrowsers() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a list of targetable bandwidths.
     */
    public com.google.api.ads.dfa.axis.v1_18.Bandwidth[] getBandwidths() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a list of targetable operating systems.
     */
    public com.google.api.ads.dfa.axis.v1_18.OperatingSystem[] getOperatingSystems() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Get an array of UserListGroups by UserListSearchCriteria.
     */
    public com.google.api.ads.dfa.axis.v1_18.UserListGroup[] getUserListGroupsByCriteria(com.google.api.ads.dfa.axis.v1_18.UserListSearchCriteria searchCriteria) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Get an array of UserLists by UserListSearchCriteria.
     */
    public com.google.api.ads.dfa.axis.v1_18.UserList[] getUserListsByCriteria(com.google.api.ads.dfa.axis.v1_18.UserListSearchCriteria searchCriteria) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a list of targetable Domain Types.
     */
    public com.google.api.ads.dfa.axis.v1_18.DomainType[] getDomainTypes() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a list of targetable OSPs.
     */
    public com.google.api.ads.dfa.axis.v1_18.OSP[] getOSPs() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a list of targetable ISPs.
     */
    public com.google.api.ads.dfa.axis.v1_18.ISP[] getISPs() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a single page of Domain Names matching the
     * given criteria.The maximum 1000 Domain Names can be retrieved in single
     * page or request.The page size can be specified in the criteria.
     * If page size is not specified in search criteria then it will assume
     * a
     * maximum page size of 1000. Also it gives error message in case page
     * size exceeds maximum limit of 1000.
     */
    public com.google.api.ads.dfa.axis.v1_18.DomainNameRecordSet getDomainNamesBySearchCriteria(com.google.api.ads.dfa.axis.v1_18.DomainNameSearchCriteria searchCriteria) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Returns a localized list of targetable MobilePlatforms.
     */
    public com.google.api.ads.dfa.axis.v1_18.MobilePlatform[] getMobilePlatforms() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;

    /**
     * Updates the properties of ad associations for creative.
     */
    public com.google.api.ads.dfa.axis.v1_18.CreativeAdAssociationSaveResultSet updateCreativeAssignmentProperties(com.google.api.ads.dfa.axis.v1_18.CreativeAdAssociationUpdateRequest associationUpdateRequest) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_18.ApiException;
}
